﻿Public Class CampoFiscal

    Public Enum FormatosCampoFiscal

        ASCII_TO_CHAR = 1000
        TEXTO
        FECHA
        FECHA_YMD
        HORA


    End Enum

    Private m_formato As FormatosCampoFiscal = Nothing
    Private m_value As Object
    Private m_mask As String = String.Empty
    Private m_suppressPattern As String = String.Empty


    Public Property Formato() As FormatosCampoFiscal
        Get
            Return m_formato
        End Get
        Set(ByVal value As FormatosCampoFiscal)
            m_formato = value
        End Set
    End Property
    Public Property Mask() As String
        Get
            Return m_mask
        End Get
        Set(ByVal value As String)
            m_mask = value
        End Set
    End Property
    Public Property SuppressPattern() As String
        Get
            Return m_suppressPattern
        End Get
        Set(ByVal value As String)
            m_suppressPattern = value
        End Set
    End Property
    Public Property Value() As Object
        Get
            Return m_value
        End Get
        Set(ByVal value As Object)
            m_value = value
        End Set
    End Property

    Public Sub New()
    End Sub
    Public Sub New(ByVal Value As Object)
        m_value = Value
    End Sub
    Public Sub New(ByVal Value As Object, ByVal Mask As String)
        m_value = Value
        m_mask = Mask
    End Sub
    Public Sub New(ByVal Value As Object, ByVal Mask As String, ByVal Pattern As String)
        m_value = Value
        m_mask = Mask
        m_suppressPattern = Pattern
    End Sub
    Public Sub New(ByVal Value As Object, ByVal Formato As FormatosCampoFiscal)
        m_value = Value
        m_formato = Formato
    End Sub

    Public Overrides Function ToString() As String

        Dim ans As String = String.Empty

        If (MyClass.Formato = Nothing) Then

            ans = Format(MyClass.Value, MyClass.Mask)
        Else
            Select Case MyClass.Formato
                Case FormatosCampoFiscal.ASCII_TO_CHAR
                    ans = Chr(MyClass.Value)
                Case FormatosCampoFiscal.FECHA
                    ans = FiscalUDFs.ToFiscalDate(MyClass.Value)
                Case FormatosCampoFiscal.HORA
                    ans = FiscalUDFs.ToFiscalTime(MyClass.Value)
                Case FormatosCampoFiscal.FECHA_YMD
                    ans = FiscalUDFs.ToFiscalDate(MyClass.Value)
                Case Else
                    ans = Format(MyClass.Value, "")
            End Select
        End If

        If TypeOf MyClass.Value Is Double Then ans = ans.Replace(",", ".")

        If MyClass.SuppressPattern.Length > 0 Then
            For Each c As Char In MyClass.SuppressPattern.ToCharArray
                ans = ans.Replace(c, "")
            Next
        End If

        Return ans
    End Function


End Class
