﻿Public Class ControladorFiscalHasar715v1 : Inherits ControladorFiscalHasar

    Public Sub New(ByVal Modelo As ModelosFiscales)
        MyBase.New(Modelo)
    End Sub

    Public Overrides Function ImprimirItem(ByVal Descripcion As String, _
                                           ByVal Cantidad As Double, _
                                           ByVal Monto As Double, _
                                           ByVal IVA As Double, _
                                           ByVal ImpuestosInternos As Double) As PaqueteFiscal

        Dim pf As PaqueteFiscal = MyClass.CrearPaquete(ComandosFiscales.IMPRIMIR_ITEM_FISCAL)
        Dim ii As Double = ImpuestosInternos

        If ImpuestosInternos > 0 Then
            If MyClass.PrecioBase Then
                ii = MyClass.GenerarCoeficienteK(Monto, ImpuestosInternos)
            Else
                ii = Monto - ImpuestosInternos
                ii = ii / (1 + (IVA / 100))
                ii = MyClass.GenerarCoeficienteK(ii, ImpuestosInternos)
            End If
        End If

        pf.AgregarCampo(Descripcion)
        pf.AgregarCampo(Cantidad, "000.0000000000")
        pf.AgregarCampo(Math.Abs(Monto), "000000.00")
        pf.AgregarCampo(IVA, "00.00")
        pf.AgregarCampo(IIf(Monto >= 0.0, "M", "m"))
        pf.AgregarCampo(ii, "+0.00000000")
        pf.AgregarCampo("0").AgregarCampo(IIf(MyClass.PrecioBase, "B", "T"))

        Return MyClass.Enviar(pf)
    End Function
End Class
