﻿Imports LibreriaFiscal
Imports LibreriaFiscal.ControladorFiscal

Public Class EpsonTiposDeResponsabilidad

    Private Shared m_tipos As Collection = Nothing

    Public Shared ReadOnly Property Tipo(ByVal Index As TiposDeResponsabilidades) As String
        Get
            If m_tipos Is Nothing Then m_tipos = Load()
            Return m_tipos(Index.ToString)
        End Get
    End Property

    Private Shared Function Load() As Collection
        Dim t As Collection = New Collection
        Dim items As Array = System.Enum.GetValues(GetType(TiposDeResponsabilidades))
        For Each item As TiposDeResponsabilidades In items
            Select Case item
                Case TiposDeResponsabilidades.RESPONSABLE_INSCRIPTO : t.Add("I", item.ToString)
                Case TiposDeResponsabilidades.RESPONSABLE_NO_INSCRIPTO : t.Add("R", item.ToString)
                Case TiposDeResponsabilidades.NO_RESPONSABLE : t.Add("N", item.ToString)
                Case TiposDeResponsabilidades.RESPONSABLE_EXENTO : t.Add("E", item.ToString)
                Case TiposDeResponsabilidades.MONOTRIBUTO : t.Add("M", item.ToString)
                Case TiposDeResponsabilidades.CONSUMIDOR_FINAL : t.Add("F", item.ToString)
                Case TiposDeResponsabilidades.NO_CATEGORIZADO : t.Add("S", item.ToString)
                Case TiposDeResponsabilidades.MONOTRIBUTO_SOCIAL : t.Add("T", item.ToString)
                Case TiposDeResponsabilidades.EVENTUAL : t.Add("C", item.ToString)
                Case TiposDeResponsabilidades.EVENTUAL_SOCIAL : t.Add("V", item.ToString)
                Case Else : t.Add("error!", item.ToString)
            End Select
        Next
        Return t
    End Function
End Class
