﻿Imports System.IO
Imports System.Text
Imports LibreriaFiscal.ExcepcionFiscal


Public Class FiscalLogger

    Private m_writer As StreamWriter
    Private m_reader As StreamReader
    Private m_enabled As Boolean = False
    Private m_file As String = ""

    Private ReadOnly Property defaultFileName() As String
        Get
            Dim sb As Text.StringBuilder = New Text.StringBuilder

            sb.Append("fiscal-")
            sb.Append(Format(Now, "dd")).Append("-")
            sb.Append(Format(Now, "MM")).Append("-")
            sb.Append(Format(Now, "yyyy")).Append(".log")



            Return sb.ToString()

        End Get
    End Property


    Public ReadOnly Property file() As String
        Get
            Select Case True
                Case m_file Is Nothing : Return defaultFileName
                Case m_file.Length = 0 : Return defaultFileName
                Case Else
                    Return m_file
            End Select
        End Get
    End Property

    Private ReadOnly Property reader() As StreamReader
        Get
            Try
                If m_reader Is Nothing Then
                    m_reader = New StreamReader(file, System.Text.Encoding.GetEncoding(1252))
                End If
            Catch ex As Exception
                Throw New ExcepcionFiscal(ExcepcionesFiscales.A_TRATAR_EN_APLICATIVO_CLIENTE, ex)
            End Try
            Return m_reader
        End Get
    End Property

    Private ReadOnly Property writer() As StreamWriter
        Get
            Try
                If m_writer Is Nothing Then
                    m_writer = New StreamWriter(file, True, System.Text.Encoding.GetEncoding(1252))
                End If
            Catch ex As Exception
                Throw New ExcepcionFiscal(ExcepcionesFiscales.A_TRATAR_EN_APLICATIVO_CLIENTE, ex)
            End Try
            Return m_writer
        End Get
    End Property

    Public Property Enabled() As Boolean
        Get
            Return m_enabled
        End Get
        Set(ByVal value As Boolean)
            m_enabled = value
        End Set
    End Property

    Public Sub New()
    End Sub

    Public Sub New(ByVal File As String)
        m_file = File
        m_enabled = False
    End Sub

    Public Sub New(ByVal File As String, ByVal Enabled As Boolean)
        m_file = File
        m_enabled = Enabled
    End Sub

    Public Sub write(ByVal Text As String)
        Try
            If Enabled Then
                writer.Write(Text)
                writer.Flush()
            End If
           
        Catch ex As Exception
            Throw New ExcepcionFiscal(ExcepcionesFiscales.A_TRATAR_EN_APLICATIVO_CLIENTE, ex)
        End Try
    End Sub

    Public Sub writeLine(ByVal Text As String)
        Try
            If Enabled Then
                writer.WriteLine(Text)
                writer.Flush()
            End If
           
        Catch ex As Exception
            Throw New ExcepcionFiscal(ExcepcionesFiscales.A_TRATAR_EN_APLICATIVO_CLIENTE, ex)
        End Try
    End Sub

    Public Function read() As String
        Dim buffer As String = ""
        Try
            If Enabled Then buffer = reader.Read
        Catch ex As Exception
            Throw New ExcepcionFiscal(ExcepcionesFiscales.A_TRATAR_EN_APLICATIVO_CLIENTE, ex)

        End Try

        Return buffer
    End Function

    Public Function readLine() As String
        Dim buffer As String = ""
        Try
            If Enabled Then buffer = reader.ReadLine
        Catch ex As Exception
            Throw New ExcepcionFiscal(ExcepcionesFiscales.A_TRATAR_EN_APLICATIVO_CLIENTE, ex)

        End Try

        Return buffer
    End Function

    Public Function readAll() As String

        Dim buffer As String = ""
        Try
            If Enabled Then buffer = reader.ReadToEnd
        Catch ex As Exception
            Throw New ExcepcionFiscal(ExcepcionesFiscales.A_TRATAR_EN_APLICATIVO_CLIENTE, ex)

        End Try

        Return buffer
    End Function

    Public Sub CopiarArchivoA(ByVal ArchivoDestino As String)
        Try
            m_writer.Close()
            m_reader.Close()

            System.IO.File.Copy(m_file, ArchivoDestino)



        Catch ex As Exception
            Throw New ExcepcionFiscal(ExcepcionesFiscales.A_TRATAR_EN_APLICATIVO_CLIENTE, ex)
        End Try
    End Sub

End Class
