﻿
''' <summary>
''' Aplicar a algunas versiones anteriores de firmware!...
''' TMU2000F
''' etc.
''' </summary>
Public Class ControladorFiscalEpsonPrev : Inherits ControladorFiscalEpson


    Friend Sub New(ByVal Modelo As ModelosFiscales)
        MyBase.New(Modelo)
    End Sub

    Public Overrides Function AbrirGaveta() As PaqueteFiscal

        Dim pf As PaqueteFiscal = MyClass.CrearPaquete(ComandosFiscales.ABRIR_GAVETA)
        Return MyClass.Enviar(pf)

    End Function


    ''' <summary>
    ''' Se toma como referencia que el campo precio va con dos decimales en vez de cuatro.
    ''' </summary>
    ''' <param name="Descripcion"></param>
    ''' <param name="Cantidad"></param>
    ''' <param name="Monto"></param>
    ''' <param name="IVA"></param>
    ''' <param name="ImpuestosInternos"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Function ImprimirItem(ByVal Descripcion As String, _
                                           ByVal Cantidad As Double, _
                                           ByVal Monto As Double, _
                                           ByVal IVA As Double, _
                                           ByVal ImpuestosInternos As Double) As PaqueteFiscal

        Dim pf As PaqueteFiscal = MyClass.CrearPaquete(ComandosFiscales.IMPRIMIR_ITEM_FISCAL)
        Dim ii As Double = ImpuestosInternos

        Select Case MyClass.DocumentoFiscal
            Case DocumentosFiscales.TICKET_C

                pf.AgregarCampo(Descripcion)
                pf.AgregarCampo(Math.Abs(Cantidad), "00000.000", ".")
                pf.AgregarCampo(Math.Abs(Monto * 100), "000000000")
                pf.AgregarCampo(IVA, "00.00", ".")
                pf.AgregarCampo(IIf(Monto < 0, "m", "M"))
                pf.AgregarCampo("0")
                pf.AgregarCampo("0")
                pf.AgregarCampo(ImpuestosInternos, "0000000.00000000", ".")

            Case Else

                pf.Comando = ComandosFiscales.IMPRIMIR_ITEM_FISCAL_X
                pf.AgregarCampo(Descripcion)
                pf.AgregarCampo(Math.Abs(Cantidad), "00000.000", ".")
                pf.AgregarCampo(Math.Abs(Monto), "0000000.0000")
                pf.AgregarCampo(IVA, "00.00", ".")
                pf.AgregarCampo(IIf(Monto < 0, "m", "M"))
                pf.AgregarCampo("0")
                pf.AgregarCampo("0")

                For index As Integer = 0 To MyClass.m_fiscalLines.Length - 1
                    pf.AgregarCampo(MyClass.m_fiscalLines(index))
                Next

                pf.AgregarCampo(0.0, "00.00", ".")
                pf.AgregarCampo(ImpuestosInternos, "0000000.00000000", ".")

        End Select

        Return MyClass.Enviar(pf)
    End Function

End Class
