﻿Public Class ControladorFiscalEpsonTM900AF : Inherits ControladorFiscal

    Private m_rcode As Integer = -1




    Private Property rcode As Integer
        Get
            Return m_rcode
        End Get
        Set(value As Integer)
            m_rcode = value
        End Set
    End Property

   Private Function GenPacket(code As Integer) As PaqueteFiscal



      Return Nothing
   End Function



#Region "implementado..."


    Public Overrides Sub Comenzar()
        Comenzar(1)
    End Sub

    Public Overrides Sub Comenzar(Port As Integer)

        EpsonDLL.ConfigurarPuerto(Port)
        EpsonDLL.ConfigurarVelocidad(9600)
        EpsonDLL.Conectar()

        'todo - validar coneccion...
    End Sub

    Public Overrides Sub Comenzar(PortName As String, ModoTrabajo As ControladorFiscal.ModosTrabajoLibreria)
        Throw New NotImplementedException
    End Sub

    Public Overrides Sub Comenzar(PortName As String)
        Throw New NotImplementedException
   End Sub

   Public Overrides Sub Finalizar()

      EpsonDLL.Desconectar()
   End Sub

#End Region

    Public Overrides Function AbrirComprobanteFiscal(Tipo As ControladorFiscal.DocumentosFiscales) As PaqueteFiscal

        Select Case Tipo
            Case DocumentosFiscales.TICKET
                Return GenPacket(EpsonDLL.AbrirComprobante(EpsonDLL.ID_TIPO_COMPROBANTE_TIQUET))

            Case DocumentosFiscales.TICKET_NC
                Return GenPacket(EpsonDLL.AbrirComprobante(EpsonDLL.ID_TIPO_COMPROBANTE_TIQUE_NOTA_DE_CREDITO))

            Case Else : Throw New NotImplementedException()
        End Select


        Throw New NotImplementedException
    End Function

    Public Overrides Function AbrirComprobanteNoFiscal() As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overrides Function AbrirComprobanteNoFiscalHomologado(Tipo As ControladorFiscal.DocumentosNoFiscalesHomologados) As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overrides Function AbrirGaveta() As PaqueteFiscal
        Throw New NotImplementedException
    End Function

   Public Overrides Function CerrarComprobanteFiscal() As PaqueteFiscal
      Dim stb As System.Text.StringBuilder = New System.Text.StringBuilder()
      Dim largo = 20
      MyBase.NumeroCpbte = 20
      EpsonDLL.ConsultarNumeroComprobanteActual(stb, largo)

      MyBase.NumeroCpbte = stb.ToString().Substring(0, stb.Length)

      Return GenPacket(EpsonDLL.CerrarComprobante())
   End Function

    Public Overrides Function CerrarComprobanteNoFiscal() As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overrides Function CerrarComprobanteNoFiscalHomologado() As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overloads Overrides Function DatosCliente(Nombre As String, NumeroDocumento As String, TipoDocumento As ControladorFiscal.TiposDeDocumento, ResponsabilidadIVA As ControladorFiscal.TiposDeResponsabilidades) As PaqueteFiscal
      Return MyClass.DatosCliente(Nombre, NumeroDocumento, TipoDocumento, ResponsabilidadIVA, F_DEL)
   End Function

   Public Overloads Overrides Function DatosCliente(Nombre As String, NumeroDocumento As String, TipoDocumento As ControladorFiscal.TiposDeDocumento, ResponsabilidadIVA As ControladorFiscal.TiposDeResponsabilidades, Direccion As String) As PaqueteFiscal
      MyBase.EnteFiscal = New EnteFiscal(Nombre, NumeroDocumento, TipoDocumento, ResponsabilidadIVA, Direccion)
      Return Nothing
   End Function

    Public Overrides Function DebeRealizarTransporte() As Boolean
        Throw New NotImplementedException
    End Function

    Public Overrides Function EstablecerNumeroEmbarque(Numero As String) As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overrides Function ImprimirItem(Descripcion As String, Cantidad As Double, Monto As Double, IVA As Double, ImpuestosInternos As Double) As PaqueteFiscal

        Dim modo As Integer = IIf(Cantidad > 0, EpsonDLL.ID_MODIFICADOR_AGREGAR, EpsonDLL.ID_MODIFICADOR_ANULAR)
        Dim civa As Integer = EpsonDLL.ID_TASA_IVA_21_00

        Select Case IVA
            Case 21 : civa = EpsonDLL.ID_TASA_IVA_21_00
            Case 10.5 : civa = EpsonDLL.ID_TASA_IVA_10_50
            Case 0 : civa = EpsonDLL.ID_TASA_IVA_EXENTO
            Case Else : civa = EpsonDLL.ID_TASA_IVA_NINGUNO
        End Select

        Return GenPacket(EpsonDLL.ImprimirItem(modo,
                                               Descripcion,
                                               Cantidad.ToString("0.000").Replace(",", "."),
                                               Monto.ToString("0.0000").Replace(",", "."),
                                               civa, ID_IMPUESTO_NINGUNO, "", ID_CODIGO_INTERNO, "1", "", EpsonDLL.AFIP_CODIGO_UNIDAD_MEDIDA_UNIDAD))

    End Function

    Public Overloads Overrides Function ImprimirPago(Descripcion As String, Monto As Double) As PaqueteFiscal

        If Monto < 0 Then Return GenPacket(EpsonDLL.Cancelar())

        Return GenPacket(EpsonDLL.CargarPago(EpsonDLL.ID_MODIFICADOR_AGREGAR,
                                             EpsonDLL.AFIP_CODIGO_FORMA_DE_PAGO_EFECTIVO, 0,
                                             Monto.ToString("0.00"), "SU PAGO", "", "", ""))
    End Function

    Public Overloads Overrides Function ImprimirPago(Descripcion As String, Monto As Double, DescripcionAdicional As String) As PaqueteFiscal
        Return ImprimirPago(Descripcion, Monto, "")
    End Function

    Public Overrides Function ImprimirTextoFiscal(Texto As String) As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overrides Function ImprimirTextoNoFiscal(Texto As String) As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overrides Function ObtenerNumeroEmbarque(Linea As Integer) As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overrides Function RealizarTransporte() As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overrides Function ReporteX() As PaqueteFiscal

        Return GenPacket(EpsonDLL.ImprimirCierreX())
    End Function

    Public Overrides Function ReporteZ() As PaqueteFiscal

        Return GenPacket(EpsonDLL.ImprimirCierreZ())
    End Function

    Public Overrides Function ReporteZPorNumeros(ZetaInicial As Long, ZetaFinal As Long, DatosGlobales As Boolean) As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overloads Overrides Function SolicitarEstado() As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overloads Overrides Function SolicitarEstado(Tipo As ControladorFiscal.SolicitudesDeEstado) As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overloads Overrides Function Subtotal() As PaqueteFiscal
        Throw New NotImplementedException
    End Function

    Public Overloads Overrides Function Subtotal(Imprime As Boolean) As PaqueteFiscal
        Throw New NotImplementedException
    End Function
End Class
