﻿Imports LibreriaFiscalV2
Imports LibreriaFiscalV2.ControladorFiscal

Public Class EpsonDocumentosFiscales

    Private Shared m_tipos As Collection = Nothing

    Public Shared ReadOnly Property DocumentoTipo(ByVal Index As DocumentosFiscales) As String
        Get
            Select Case Index
                Case DocumentosFiscales.FACTURA_A, DocumentosFiscales.TICKET_FACTURA_A
                    Return "T"
                Case DocumentosFiscales.FACTURA_B, DocumentosFiscales.TICKET_FACTURA_B
                    Return "T"

                Case DocumentosFiscales.NOTA_CREDITO_BC, DocumentosFiscales.NOTA_CREDITO_A
                    Return "M"
                Case Else
                    Return "error!"
            End Select
        End Get
    End Property

    Public Shared ReadOnly Property Letra(ByVal Index As DocumentosFiscales) As String
        Get
            Select Case Index
                Case DocumentosFiscales.FACTURA_A, _
                     DocumentosFiscales.TICKET_FACTURA_A, DocumentosFiscales.NOTA_CREDITO_A
                    Return "A"
                Case DocumentosFiscales.FACTURA_B, _
                     DocumentosFiscales.TICKET_FACTURA_B, DocumentosFiscales.NOTA_CREDITO_BC
                    Return "B"
                Case Else
                    Return "error!"
            End Select
        End Get
    End Property

    Public Shared ReadOnly Property Tipo(ByVal Index As DocumentosFiscales) As DocumentosFiscales
        Get
            If m_tipos Is Nothing Then m_tipos = Load()
            Return m_tipos(Index.ToString)
        End Get
    End Property

    Private Shared Function Load() As Collection
        Dim t As Collection = New Collection
        Dim items As Array = System.Enum.GetValues(GetType(DocumentosFiscales))
        For Each item As DocumentosFiscales In items
            t.Add(item, item.ToString)
        Next
        Return t
    End Function

End Class
