﻿Imports System.IO
Imports LibreriaFiscalV2
Imports LibreriaFiscalV2.ControladorFiscal
Imports System.Text

Public Class FormTest

    Private cf As ControladorFiscal
    Private pf As PaqueteFiscal

    Private Sub FormTest_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load



        Dim items As Array = System.Enum.GetValues(GetType(ModelosFiscales))

        combo_models.Items.Clear()

        For Each item As ModelosFiscales In items
            combo_models.Items.Add(item)
        Next


        combo_models.SelectedItem = ModelosFiscales.HASAR_441


    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            cf = CrearInstancia(combo_models.SelectedItem)
            cf.Timeout = 2000

            cf.LoggerEnabled("c:\fiscal.log") = False

            cf.Comenzar(4)

            Button1.Enabled = False
            Button2.Enabled = True




        Catch ex As Exception
            MessageEx(ex)
        End Try
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Try
            cf.Finalizar()
            cf = Nothing
            Button2.Enabled = False
            Button1.Enabled = True
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Try
            cf.AbrirComprobanteNoFiscal()
            cf.ImprimirTextoNoFiscal("texto no fiscal")
            cf.CerrarComprobanteNoFiscal()

            ShowInfo(cf)

        Catch ex As Exception
            MessageEx(ex)
        End Try

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        Try
            cf.AbrirComprobanteFiscal(DocumentosFiscales.TICKET_C)
            cf.ImprimirTextoFiscal("texto adicional...")
            cf.ImprimirItem("MANZANAS DELICIOSAS", 0.85, 0.1, 21.0, 0.0)

            If MsgBox("Cancela comprobante ?", MsgBoxStyle.Question Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2) = MsgBoxResult.Yes Then
                cf.ImprimirPago("CANCELA", -1.0)
                ShowInfo(cf)
            Else
                cf.ImprimirPago("EFECTIVO", 50.0)
                cf.CerrarComprobanteFiscal()

                ShowInfo(cf)

                MsgBox("Numero : " & cf.Respuesta.ParseInteger(3).ToString)
            End If

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try


    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Try
            cf.ReporteX()

            ShowInfo(cf)

            MsgBox("Numero cierre X : " & cf.Respuesta.ParseInteger(3).ToString)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button6_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button6.Click

        Try
            cf.DatosCliente("JORGE", "33333333339", _
                            TiposDeDocumento.TIPO_CUIT, _
                            TiposDeResponsabilidades.RESPONSABLE_INSCRIPTO, "LA PAZ 2021")
            cf.AbrirComprobanteFiscal(DocumentosFiscales.TICKET_FACTURA_A)
            cf.ImprimirItem("MANZANAS DELICIOSAS", 0.85, 0.1, 21.0, 0.0)
            cf.ImprimirPago("EFECTIVO", 50.0)
            cf.CerrarComprobanteFiscal()

            ShowInfo(cf)

            MsgBox("Numero : " & cf.Respuesta.ParseInteger(3).ToString)

        Catch ex As Exception
            MessageEx(ex)
        End Try
    End Sub

    Private Sub ShowInfo(ByVal controlador As ControladorFiscal)

        check_ef.Checked = controlador.HuboErrorFiscal
        check_ep.Checked = controlador.HuboErrorImpresor
        check_cierreZ.Checked = controlador.Respuesta.EstadoFiscal(EstadosFiscales.FECHA_INVALIDA)

        text_answer.Text = controlador.Respuesta.ToString(controlador.SecuenciaEscape)
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Me.Hide()
        Me.Dispose()
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click

        If MsgBox("Realizar cierre jornada fiscal ?", MsgBoxStyle.Question Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2) = MsgBoxResult.Yes Then
            cf.ReporteZ()
            ShowInfo(cf)
            MsgBox("Numero cierre Z : " & cf.Respuesta.ParseInteger(3).ToString)
        End If
    End Sub

    Private Sub button_datetime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_datetime.Click

        Try
            Dim ans As DateTime = cf.FechaYHora.ToString

            ShowInfo(cf)

            MsgBox("Fecha y Hora : " & ans.ToString)

            cf.FechaYHora = ans

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        Try
            Dim linea As Integer = Integer.Parse(InputBox("Ingrese linea a leer", "HEAD-FOOTER", 1))
            Dim ans As String = cf.EncabezadoPie(linea)

            MsgBox("Dato linea ( " & linea.ToString & " ) : " & ans)

            ShowInfo(cf)
        Catch ex As Exception
            MessageEx(ex)
        End Try
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click

        cf.SolicitarEstado()
        ShowInfo(cf)


    End Sub

    Private Sub button_detalle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_detalle.Click
        Dim respuesta As String = String.Empty

        If Not cf.Respuesta Is Nothing Then

            respuesta = "detalle respuesta controlador " & vbCrLf & vbCrLf
            respuesta &= "nro. secuencia : " & cf.Respuesta.Secuencia.ToString & vbCrLf
            respuesta &= "comando        : " & cf.Respuesta.Comando.ToString & vbCrLf
            respuesta &= "CAMPOS : " & vbCrLf & vbCrLf

            For index As Integer = 1 To cf.Respuesta.Campos.Count
                Select Case index
                    Case 1 : respuesta &= cf.Respuesta.Campos(index).ToString & " - ESTADO FISCAL !" & vbCrLf
                    Case 2 : respuesta &= cf.Respuesta.Campos(index).ToString & " - ESTADO IMPRESOR !" & vbCrLf
                    Case Else
                        respuesta &= cf.Respuesta.Campos(index).ToString & vbCrLf
                End Select
            Next

            MsgBox(respuesta)


        End If

    End Sub

    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click
        Dim respuesta As String = String.Empty

        If Not cf.Respuesta Is Nothing Then

            respuesta = "detalle respuesta fiscal " & vbCrLf & vbCrLf

            For index As EstadosFiscales = 0 To 15
                respuesta &= index.ToString & " = " & cf.Respuesta.EstadoFiscal(index).ToString & vbCrLf
            Next

            MsgBox(respuesta)

        End If
    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        Dim respuesta As String = String.Empty

        If Not cf.Respuesta Is Nothing Then

            respuesta = "detalle respuesta impresor " & vbCrLf & vbCrLf

            For index As EstadosImpresor = 0 To 15
                respuesta &= index.ToString & " = " & cf.Respuesta.EstadoImpresor(index).ToString & vbCrLf
            Next

            MsgBox(respuesta)

        End If
    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click
        Try


            If cf.Modelo.ToString.Contains("EPSON") Then

                'cf.DatosCliente("JORGE", "33333333339", _
                '            TiposDeDocumento.TIPO_CUIT, _
                '            TiposDeResponsabilidades.RESPONSABLE_INSCRIPTO, "LA PAZ 2021")

                'cf.AbrirComprobanteFiscal(DocumentosFiscales.NOTA_CREDITO_A)


                ' nota de credito B

                cf.DatosCliente("CONSUMIDOR FINAL", "0", _
                            TiposDeDocumento.TIPO_DNI, _
                            TiposDeResponsabilidades.CONSUMIDOR_FINAL, "LA PAZ 766")

                cf.AbrirComprobanteFiscal(DocumentosFiscales.NOTA_CREDITO_BC)


                cf.ImprimirItem("BERNUDA MERYS", 26.0, 180.0, 0.0, 0.0)
                cf.ImprimirPago("EFECTIVO", 5000.0)
                cf.CerrarComprobanteFiscal()

                ShowInfo(cf)


            Else

                cf.EstablecerNumeroEmbarque("1110")
                cf.DatosCliente("JORGE", "33333333339", TiposDeDocumento.TIPO_CUIT, TiposDeResponsabilidades.RESPONSABLE_INSCRIPTO)
                cf.AbrirComprobanteNoFiscalHomologado(DocumentosNoFiscalesHomologados.TICKET_NOTA_CREDITO_A)

                cf.ImprimirItem("MANZANAS DELICIOSAS", 0.85, 0.1, 21.0, 0.0)
                cf.ImprimirPago("EFECTIVO", 50.0)
                cf.CerrarComprobanteNoFiscalHomologado()

                ShowInfo(cf)
            End If
            MsgBox("Numero : " & cf.Respuesta.ParseInteger(3).ToString)

        Catch ex As Exception
            MessageEx(ex)
        End Try
    End Sub

    Private Sub Button16_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Try
            Dim linea As Integer = Integer.Parse(InputBox("Ingrese linea a leer (1-2)", "NRO. REMITO", 1))
            Dim ans As String = cf.ObtenerNumeroEmbarque(linea).Campos(3)

            MsgBox("Dato linea ( " & linea.ToString & " ) : " & ans)

            ShowInfo(cf)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub


    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InformexZ.Click
        Try
            cf.ReporteZPorNumeros(1, 1, True)
            ShowInfo(cf)
        Catch ex As Exception
            MessageEx(ex)
        End Try

    End Sub

    Private executeAndValidate()

    Private Sub MessageEx(ByVal e As ExcepcionFiscal)
        MsgBox(e.Message)
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        Try
            cf.AbrirComprobanteFiscal(DocumentosFiscales.TICKET)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button12_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        Try

            cf.ImprimirItem("MANZANAS DELICIOSAS", 3.0, 0.1, 21.0, 0.0)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button17_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.Click
        Try
          
            cf.ImprimirPago("EFECTIVO", 50.0)
           
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button18_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.Click
        Try

            cf.CerrarComprobanteFiscal()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.Click
        cf.ImprimirPago("CANCELA", -1.0)
    End Sub

    Private Sub Button20_Click(sender As Object, e As EventArgs) Handles Button20.Click
        Try
            Dim ans As DateTime = cf.AbrirGaveta.ToString

            ShowInfo(cf)

           
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

   
End Class
